﻿package {
	import com.robotacid.engine.Car;
	import com.robotacid.game.Key;
	import com.robotacid.geom.Pixel;
	import com.robotacid.phys.Particle;
	import flash.display.Bitmap;
	import flash.display.Graphics;
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.ui.Keyboard;
	
	[SWF(width = "640", height = "480", frameRate="12", backgroundColor = "#CCCCCC")]
	/**
	 * ...
	 * @author steed
	 */
	public class Main extends Sprite {
		
		public var canvas:Sprite;
		public var test:Bitmap;
		public var gfx:Graphics;
		public var start_x:int = 160;
		public var start_y:int = 120;
		public var p:Pixel = new Pixel();
		public var car:Car;
		[Embed(source = "assets/test.png")] public static var TestB:Class;
		
		public function Main():void {
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e:Event = null):void {
			removeEventListener(Event.ADDED_TO_STAGE, init);
			canvas = new Sprite();
			test = new TestB();
			canvas.addChild(test);
			var shape:Shape = new Shape();
			canvas.addChild(shape);
			gfx = shape.graphics;
			canvas.scaleX = canvas.scaleY = 2;
			redo();
			addChild(canvas);
			addEventListener(Event.ENTER_FRAME, onEnterFrame);
			addEventListener(MouseEvent.CLICK, onClick);
			Key.init(stage);
		}
		
		private function redo():void{
			car = new Car(new Particle(160, 120), new Particle(170, 120), test.bitmapData);
		}
		
		private function onEnterFrame(e:Event):void{
			gfx.clear();
			gfx.lineStyle(1, 0);
			car.draw(gfx);
			car.main();
			if(Key.isDown(Keyboard.RIGHT)){
				(car.a as Particle).px -= 1;
				(car.b as Particle).px -= 1;
			}
			if(Key.isDown(Keyboard.LEFT)){
				(car.a as Particle).px += 1;
				(car.b as Particle).px += 1;
			}
		}
		
		private function onClick(e:MouseEvent):void{
			redo();
		}
	}
	
}